package algorithms;

import java.util.List;
import objects.DistanceMatrix;
import objects.Template;

public class Classifier1NN extends Classifier {

    @Override
    public int classify(Template templateQuery, List<Template> templatesGallery) {

        // get k closest descriptors
        Template closestTemplate = new Template(0, "", null);
        DistanceTemplates distanceTemplates = getDistanceTemplates();
        DistanceMatrix distanceMatrix = getDistanceMatrix();
        double minDistance = Double.MAX_VALUE;
        for (Template template : templatesGallery) {
            double distance = getDistanceMatrix() == null ? distanceTemplates.getDistance(template, templateQuery) : distanceMatrix.getDistance(template, templateQuery);
            if (minDistance > distance) {
                minDistance = distance;
                closestTemplate = template;
            }
        }
        return closestTemplate.getSubject();
    }
}
